package myList;

@SuppressWarnings("rawtypes")
public class MyList implements Iterable{
	private Cell first;
	private Cell last;
	
	public MyList (){
		first = last = null;
	}
	
	public MyList (Object data){
		Cell c = new Cell(data);
		first = last = c;
	}
	
	public boolean isEmpty (){
		return (first == null);
	}
	
	public MyIterator iterator() {
		return new MyIterator(first);
	}
	
	public void addLast (Object data){
		Cell c = new Cell(data);
		if (isEmpty())
			first = last = c;
		else
		{
			last.setNext(c);
			last = c;
		}
	}
	
	public void addFirst (Object data){
		Cell c = new Cell(data, first);
		if (isEmpty())
			last = c;
		first = c;
	}
	
	public Object getLast (){
		if (isEmpty())
			return null;
		return last.getData();
	}
	
	public Object getFirst (){
		if (isEmpty())
			return null;
		return first.getData();
	}
	
	public void removeLast (){
		if (!isEmpty()){
			if (first.getNext() == null)
				first = last = null;
			else
			{
				Cell prev = first;
				Cell curr = first.getNext();
				
				while (curr.getNext() != null){
					prev = curr;
					curr = curr.getNext();
				}
				
				prev.setNext(null);
				last = prev;
			}
		}
	}
	
	public void removeFirst (){
		if (!isEmpty())
			if (first == last){
				first = last = null;
			}
			else
				first = first.getNext();
	}
	
	public int size (){
		MyIterator it = iterator();
		int size = 0;
		while (it.hasNext()){
			it.next();
			size++;
		}
		return size;
	}
	
	public boolean contains (Object data){
		for (Object d : this)
			if (d.equals(data))
				return true;
		return false;
	}
	
	public void clear(){
		first = last = null;
	}
	
	public String toString(){
		String res = "";
		for (Object data : this)
			res += data + " ";
		if ( res == "")
			return "Empty list";
		return res;
	}
}
